import fs from 'fs';
import Path from './Path.js';

export default class Dir {

  static async filenamesWithPath(dirPath) {
    const filenamesInPath = await this.filenames(dirPath);
    return this._addPath(dirPath, filenamesInPath);
  }

  static async filenames(dirPath) {
    const elementsInPath = await this.elements(dirPath);
    const result = [];
    for (const element of elementsInPath) {
      // TODO: This should be moved to another file.
      const stats = await fs.promises.stat(element);
      if (stats.isFile()) {
        result.push(element);
      }
    }
    return result;
  }

  static async elementsWithPath(dirPath) {
    const elementsInPath = await this.elements(dirPath);
    return this._addPath(dirPath, elementsInPath);
  }

  static async elements(dirPath) {
    return fs.promises.readdir(dirPath);
  }

  static _addPath(path, elements) {
    const result = [];
    for (const element of elements) {
      result.push(Path.add(path, element));
    }
    return result;
  }

}
